import java.awt.*;
import java.awt.event.*;

/** This class is used to create the splash screen
 *
 @author TSS
	   * @version 3.0
 * @see Window
 */
public class Splash extends Window {
    
  /**
		*  Image to Display
		*/
	   private Image splashImage;
	   /**
		* Height of Image
		*/
	   private int  imgHeight;
	   /**
		* Width of Image
		*/
	   private int imgWidth;
	   /**
		* Image name
		*/
	   private String imgName;
	   /**
		* Border Size
		*/
	   private static final int BORDERSIZE = 0;
	   /**
		* Color of the Border
		*/
	   private static final Color BORDERCOLOR = Color.blue;
	   /**
		* Toolkit
		*/
  Toolkit tk;

  /** Constructor to create the splash screen
	*
	* @param f Frame
	* @param imgName String image name
	*/
  public Splash(Frame f, String imgName) {
    super(f);
    this.imgName = imgName;
    tk = Toolkit.getDefaultToolkit();
    splashImage = loadSplashImage();
    showSplashScreen();
    f.addWindowListener(new WindowListener());
  }
  
  
   /** This will start to load the images onto the splash screen
   *
   * @return an image of the splash screen
   */
  public Image loadSplashImage() {
    MediaTracker tracker = new MediaTracker(this);
    Image result;
    result = tk.getImage(imgName);
    tracker.addImage(result, 0);
    try {
      tracker.waitForAll();
      }
    catch (Exception e) {
      e.printStackTrace();
      }
    imgWidth = result.getWidth(this);
    imgHeight = result.getHeight(this);
    //System.out.println(imgWidth + " x " + imgHeight);
    return (result);
  }

  
  
  /** This will show the splash screen
   *
   */
  public void showSplashScreen() {
    Dimension screenSize = tk.getScreenSize();
    setBackground(Color.white);
    int w = imgWidth + (BORDERSIZE * 2);
    int h = imgHeight + (BORDERSIZE * 2);
    //int w = imgWidth;
    //int h = imgHeight;
    int x = (screenSize.width - w) /2;
    int y = (screenSize.height - h) /2;
    setBounds(x, y, w, h);
    setVisible(true);
  }
  
  
   /**
 * Overrides the Window paint(Graphics) method
   *
   * @param g Graohics
   */
  public void paint(Graphics g) {
   g.drawImage(splashImage, BORDERSIZE, BORDERSIZE, imgWidth, imgHeight, this);
  }
  
  
  /**
  * This class is used
	*
	* @author TSS
	* @version 3.0
	*/
  class WindowListener extends WindowAdapter {
      
	  /**
* Overrides WindowAdapter's windowOpened(WindowEvent) method
		*
		* @param we Window Event
		*/
        public void windowOpened(WindowEvent we) {
            setVisible(false);
            dispose();
        }
  }
  
  
}