import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.net.URL;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEditSupport;


/** This is the main class for the project it contains the main start method
 * and the main gui that is loaded on start up.
 *
 * Disclaimer: Some of the code and ideas were taken from the ShartTools project
 *            The previous project team integrated their code with the borrowed
 *            code.
 *
* @author TSS
	   * @version 3.0
 */
public final class TerpSpreadSheet extends JFrame implements ListSelectionListener, MouseListener, ActionListener, TerpOfficeAppInterface {
	/**
	* Find Next Menu Item
	*/
    private JMenuItem findNextMenuItem;
    

    
	/** User Defined Functions - Names */
		private Vector userDefFunctions = getUserFunctionNames();
		/** User Defined Functions  - JList*/
		final JList uFunList = new JList(userDefFunctions);
		/** User Defined Functions  just vector*/
		private Vector vec = new Vector();
		/** User Defined Functions Text Field */
		JTextField jTextField1 = new JTextField();
		/** User Defined Functions - Mehods*/
		private static Vector userMethods = null;
		/** User Defined Functions - Mehtod Names */
		private static Vector userFunctionNames = null;
    
    
    
    //User Defined  Graph Variables
 	/** User Defined Graphs- Names */
		private Vector userDefGraphs = getUserGraphNames();
		/** User Defined Graphs- JList */
		final JList uGraphList = new JList(userDefGraphs);
		/** User Defined Graphs- Methods */
		private static Vector userGraphs = null;
		/** User Defined Graphs- Method Names */
		private static Vector userGraphNames = null;
 
    
	/** User Defined Functions- Class Name */
		private static String userFunctionsClass = "UserFunctions";
		/** User Defined Graphs-Class Name */
		 private static String userGraphsClass = "UserGraphs";
    
    // ADDED BY AL FOR FORMULA BAR, UNDO, REDO
    	/** Formula Text Field */
		private JTextField formulaField;
		/** Undo Mananger */
		private UndoManager undoManager= new UndoManager();
		/** Undo Support */
		private UndoableEditSupport undoSupport = new UndoableEditSupport();
    
    /** This method is required to correctly implement the undo/redo
     * functionality.
     *
     * @return a new undomanage
     */
    public UndoManager getUndoManager() { return undoManager; }
    /** This method is required to correctly implement the undo/redo
     * functionality.
     * @return a undo manager support
     */
    public UndoableEditSupport getUndoSupport() { return undoSupport; }
    
    /** Determines if the spreadsheet is a stand alone function.
     */
    public boolean m_isStandAlone = false;
    
    // the rest of the components
    /** an instance of the gui container.
     */
    private Container m_container;
    /** an instance of the gui main table.
     */
    private JTable m_table;
    /** an instance of the gui main scroll pane.
     */
    private JScrollPane m_scrollPane;
    /** an instance of the gui main tool bar.
     */
    private JToolBar m_toolBar;
    /** an instance of the gui main menu bar.
     */
    private JMenuBar m_menuBar;
    /** an instance of the gui main bar panel.
     */
    private JPanel m_barPanel;
    /** an instance of the gui main input pane.
     */
    private JPanel m_inputPane;
    /** the gui bold toggle button to indicate pressed/depressed.
     */
    public  JToggleButton boldButton;
    /** the gui italics toggle button to indicate pressed/depressed.
     */
    public  JToggleButton italicButton;
    
    /** current spreadsheet configuration file.
     */
    static private Config m_config;
    
    /** a copy of the current table model.
     */
    private UMTableModel m_tableModel;
    /** the current number of rows highlighted.
     */
    private ListSelectionModel m_rowSelectionModel;
    /** the current number of columns highlighted.
     */
    private ListSelectionModel m_columnSelectionModel;
    
    // these are used to access our global objects
    /** gets the current configuration file.
     *
     * @return current configuration file
     */
    static public Config getConfig() { return m_config; }
    
    /** gets the main main table.
     *
     * @return current main table
     */
    public JTable getTable() { return m_table; }
    /** gets the main table model.
     *
     * @return current table model
     */
    public UMTableModel getTableModel() { return m_tableModel; }
    /** gets the main tool bar.
     *
     * @return main tool bar
     */
    public JToolBar getToolBar() { return m_toolBar; }
    /** gets the main menu bar.
     *
     * @return main menu bar
     */
    public JMenuBar getJMenuBar() { return m_menuBar; }
    
    
    /** operations allowed within file tool bar.
     */
    private FileMenuOp m_fileMenuOp;
    /** operations allowed within edit tool bar.
     */
    private EditMenuOp m_editMenuOp;
    /** operations allowed within format tool bar.
     */
    private FormatMenuOp m_formatMenuOp;
    /** operations allowed within functions tool bar.
     */
    private FunctionsMenuOp m_functionsMenuOp;
    
	/** help menu option*/
	private HelpMenuOp m_helpMenuOp; // new
	/** graph menu option*/
	private GraphsMenuOp m_graphsMenuOp; //AMAR
    
    // initialize JMenu fields
    // menu headings
    /** the gui menu structure for file.
     */
    private JMenu m_fileMenu;
    /** the gui menu structure for edit.
     */
    private JMenu m_editMenu;
    
	/** format menu option*/
		private JMenu m_formatMenu;
		/** user Graph menu option*/
		private JMenu userGraph;
		/** user Fubctions menu option*/
		private JMenu userFunction;
    
		// submenu headings
		/** submenu  option*/
		private JMenu insertMenu;
		/** submenu  option*/
		private JMenu deleteMenu;
    
    
    /** the gui menu structure for functions.
     */
    private JMenu m_functionsMenu;
    
    /** the gui menu structure for help.
     */
    private JMenu m_helpMenu; // new
	/** the gui menu structure for graphs
			 */
    private JMenu m_graphsMenu; //AMAR
    
    /** the gui structure for new pop-up menus.
     */
    private PopupMenu m_popup;
    
    // Tool bar selections
    /** the gui dropdown box for the list of fonts.
     */
    public JComboBox m_fontList;
    /** the gui dropdown box for the list of font sizes.
     */
    public JComboBox m_fontSizeList;
    
    
    /** Tool bar selections for FUNCTION serey
     */
    public JComboBox m_functionList;
    
    // recources
    /** the shortcut image for the new icon.
     */
    final private ImageIcon newIcon = getImageIcon("new.gif");
    /** the shortcut image for the open icon.
     */
    final private ImageIcon openIcon = getImageIcon("open.gif");
    /** the shortcut image for the save icon.
     */
    final private ImageIcon saveIcon = getImageIcon("save.gif");
    /** the shortcut image for the print icon.
     */
    final private ImageIcon printIcon = getImageIcon("print.gif");
    /** the shortcut image for the cut icon.
     */
    final private ImageIcon cutIcon = getImageIcon("cut.gif");
    /** the shortcut image for the copy icon.
     */
    final private ImageIcon copyIcon = getImageIcon("copy.gif");
    /** the shortcut image for the paste icon.
     */
    final private ImageIcon pasteIcon = getImageIcon("paste.gif");
    /** the shortcut image for the bold icon.
     */
    final private ImageIcon boldIcon = getImageIcon("bold.gif");
    /** the shortcut image for the italics icon.
     */
    final private ImageIcon italicIcon = getImageIcon("italic.gif");
    
	/** Forward color icon*/
		final private ImageIcon fcolorIcon = getImageIcon("fcolor.gif");
		/** Back color icon*/
		final private ImageIcon bcolorIcon = getImageIcon("bcolor.gif");
		/** Format icon*/
		final private ImageIcon formatIcon = getImageIcon("format.gif");
	// serey
	   // this sets where you want to place the point
	   /** Point x value*/
	   static private int x = 50;
	   /** Point y value*/
	   static private int y = 50;
    
	   // this sets the dim of rows and columns
	   /** Row value*/
	   static private int w = 500;
	   /** Col value*/
	   static private int h = 500;
    
    
    /** starting index for row.
     */
    public static int m_baseRow = 0;
    /** starting index for columns.
     */
    public static int m_baseCol = 1;
    /** maximum default size for row.
     */
    public static int m_maxRow = 50;
    /** maximum default size for columns.
     */
    public static int m_maxCol = 50;
    
    //Newly added - JJ
	/** File History value*/
    private FileHistory fileHist = null;
    
    /** TerpSpreadSheet Public constructor to create a new spreadsheet.
     */
    public TerpSpreadSheet() {
        super("TerpSpreadsheet");
                        // Newly Added - JJ
        Splash mySplash = new Splash(this, "TerpSpreadsheet_Splash.gif");
       try {
        Thread.sleep( 3000 ) ;
        } catch ( java.lang.InterruptedException e ) { System.out.println( e.getMessage() ) ;}
    
   
        // serey location of dimension
        x = m_config.getInt("X");
        y = m_config.getInt("Y");
        System.out.println("x is " + x );
        System.out.println("y is " + y );
        System.out.println("VERSION 3.0");
        
        Dimension scrdim = getToolkit().getScreenSize();
        
        // make sure the point is valid
        if (x >= 0 && y >= 0 && x < (int)scrdim.getWidth() && y < (int)scrdim.getHeight())
            setLocation(x, y);
        
        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        // get content pane
        m_container = this.getContentPane();
        m_container.setLayout(new BorderLayout());
        
        // Create a pane for input bar and toolbar
        m_inputPane = new JPanel();
        m_inputPane.setLayout(new BorderLayout());
        
        //m_inputBar = new JTextField();
        // create the table
        m_table = new JTable(m_maxRow+1, m_maxCol+1);
        m_table.setGridColor(Color.lightGray);
        
        // create the Function combobox in the table
        //Start
        java.awt.GraphicsEnvironment ge =
        java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        m_functionList = new JComboBox();
        m_functionList.addItem("[Automatic]");
        m_functionList.addItem("Sum");
        m_functionList.addItem("Average");
        m_functionList.addItem("Max");
        m_functionList.addItem("Min");
        m_functionList.addItem("Square Root");
        m_functionList.addItem("Sine");
        m_functionList.addItem("Count");
        m_functionList.addItem("User Defined");
        
        m_functionList.setBackground(Color.white);
        m_functionList.setSelectedIndex(0);
        m_functionList.addItemListener( new ItemListener() {
            public void itemStateChanged( ItemEvent e ) {
                if( e.getStateChange() == ItemEvent.SELECTED ) {
                    String s = (String)e.getItem();
                    
                    if( s.equals("Sum") )
                        m_functionsMenuOp.sumOp();
                    else if( s.equals("Average") )
                        m_functionsMenuOp.averageOp();
                    else if( s.equals("Max") )
                        m_functionsMenuOp.maxOp();
                    else if( s.equals("Min") )
                        m_functionsMenuOp.minOp();
                    else if( s.equals("Square Root") )
                        m_functionsMenuOp.sqrtOp();
	else if(!(s.equals("Sine")) )
                        m_functionsMenuOp.sineOp();
                    else if( s.equals("Count") )/*FAULT:	else if(!(s.equals("Count")) )*/
                        m_functionsMenuOp.countOp();
                    else if (s.equals("User Defined"))/*FAULT:	else if (!(s.equals("User Defined")))*/
                        System.out.println("User Functions");
                    
                    m_functionList.setSelectedIndex(0);
                }
            }
        });
        //End
        
        
        
        // createS the Fonts combobox in the table
        //java.awt.GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        String[] fontNames = ge.getAvailableFontFamilyNames();
        
        m_fontList = new JComboBox();
        m_fontList.addItem("[Automatic]");
        for (int i = 0; i < fontNames.length; i++)
            m_fontList.addItem(fontNames[i]);
        
        m_fontList.setBackground(Color.white);
        m_fontList.setSelectedIndex(2);
        m_fontList.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                if (e.getStateChange() == ItemEvent.SELECTED)
                    m_formatMenuOp.setFontOp(e.getItem());
            }
        });
        
        // creates list of font sizes
        String [] fontSizes = { "-", "8", "9", "10", "11", "12", "14", "16", "18",
        "20", "24", "26", "28" ,"36", "48", "72"};
        
        m_fontSizeList = new JComboBox(fontSizes);
        m_fontSizeList.setBackground(Color.white);
        m_fontSizeList.setSelectedIndex(5);
        m_fontSizeList.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                if (e.getStateChange() == ItemEvent.SELECTED)
                    m_formatMenuOp.setFontSizeOp(e.getItem());
            }
        });
        // initialize table to default fonts and font sizes
        try {
            m_table.setFont(new Font(fontNames[1], Font.PLAIN, Integer.parseInt(fontSizes[5])));
        } catch (Exception fontE) {
            m_table.setFont(new Font(fontNames[1], Font.PLAIN, 12));
        }
        
        // Sets up fileMenu
        m_fileMenu = new JMenu("File", true);
        m_fileMenu.setMnemonic(KeyEvent.VK_F);
        
        // New
        JMenuItem menuItem = new JMenuItem("New...");
        menuItem.setMnemonic(KeyEvent.VK_N);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_fileMenuOp.newFile();
            }
        });
        m_fileMenu.add(menuItem);
        
        // Open
        menuItem = new JMenuItem("Open...");
        menuItem.setMnemonic(KeyEvent.VK_O);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                int choice = 2;
                if( m_tableModel.isModified() )
                    choice = m_fileMenuOp.queryForSave();
                if( choice == 0 )
                    m_fileMenuOp.saveFile();
                
                m_fileMenuOp.openFile();
                
            }
        });
        m_fileMenu.add(menuItem);
        m_fileMenu.addSeparator();
        
        // Save
        menuItem = new JMenuItem("Save");
        menuItem.setMnemonic(KeyEvent.VK_S);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_fileMenuOp.saveFile();
            }
        });
        m_fileMenu.add(menuItem);
        
        // Save As
        menuItem = new JMenuItem("Save As...");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_fileMenuOp.saveAsFile();
            }
        });
        m_fileMenu.add(menuItem);
        m_fileMenu.addSeparator();
        
        // Print
        menuItem = new JMenuItem("Print...");
        menuItem.setMnemonic(KeyEvent.VK_P);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_fileMenuOp.printFile();
            }
        });
        m_fileMenu.add(menuItem);
        
        // Exit, may need to fix
        m_fileMenu.addSeparator();
        menuItem = new JMenuItem("Exit");
        menuItem.setMnemonic(KeyEvent.VK_E);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                //Newly Added - JJ
                fileHist.saveFileHistory(new File("recentFileHistory.log"));
                m_fileMenuOp.exitFile(2);
            }
        });
        m_fileMenu.add(menuItem);
        
        //AMAR
        //Set up Graphs Menu
        m_graphsMenu = new JMenu( "Graphs", true );
        m_graphsMenu.setMnemonic(KeyEvent.VK_G);
        menuItem = new JMenuItem( "Pie" );
        menuItem.addActionListener( new ActionListener()  {
            public void actionPerformed( ActionEvent evt ) {
                m_graphsMenuOp.pieGraph();
            }
        });
        m_graphsMenu.add( menuItem );
        
        menuItem = new JMenuItem( "Column" );
        menuItem.addActionListener( new ActionListener()  {
            public void actionPerformed( ActionEvent evt ) {
                m_graphsMenuOp.columnGraph();
            }
        });
        m_graphsMenu.add( menuItem );
        
        menuItem = new JMenuItem( "Line" );
        menuItem.addActionListener( new ActionListener()  {
            public void actionPerformed( ActionEvent evt ) {
                m_graphsMenuOp.lineGraph();
            }
        });
        m_graphsMenu.add( menuItem );
        
        menuItem = new JMenuItem( "Row" );
        menuItem.addActionListener( new ActionListener()  {
            public void actionPerformed( ActionEvent evt ) {
                m_graphsMenuOp.rowGraph();
            }
        });
        m_graphsMenu.add( menuItem );
        //AMAR
        
        
        //User Graphs
        
        userGraph = new JMenu("User Defined",true);
        System.out.println("Graph Size: "+userGraphNames.size());
        
        for(int t=0; t< userGraphNames.size();t++) {
            JTable table=getTable();
            UMTableModel tablemodel=getTableModel();
            final Object[] tst ={this};
            final Method temp= (Method) userGraphs.elementAt(t);
            
            
            System.out.println(t + "Graph Name " +  userGraphNames.elementAt(t).toString());
            menuItem = new JMenuItem(userGraphNames.elementAt(t).toString());
            menuItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    //Put the call
                    try{
                        temp.invoke(temp,tst);
                    }
                    catch (Exception EX )
                    {  	EX.printStackTrace();}
                    
                }
            });
            userGraph.add(menuItem);
        }
        m_graphsMenu.add(userGraph);
        
        
        
        //FileHistory - Newly Added - JJ
        File iniFile = new File("recentFileHistory.log");
        fileHist = new FileHistory(this, iniFile, m_fileMenu);
        
        
        //Set up Edit menu
        m_editMenu = new JMenu("Edit", true);
        m_editMenu.setMnemonic(KeyEvent.VK_E);
        
        // ADDED BY AL UNDO
        menuItem = new JMenuItem("Undo");
        menuItem.setMnemonic(KeyEvent.VK_Z);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                System.out.println("undo actionperformed");
                m_editMenuOp.undo_MenuItemActionPerformed();
                System.out.println("undo action performed exited");
            }
        });
        m_editMenu.add(menuItem);
        
        // ADDED BY AL REDO
        menuItem = new JMenuItem("Redo");
        menuItem.setMnemonic(KeyEvent.VK_Y);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Y, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.redoActionPerformed();
            }
        });
        m_editMenu.add(menuItem);
        m_editMenu.addSeparator();
        
        // Cut
        menuItem = new JMenuItem("Cut");
        menuItem.setMnemonic(KeyEvent.VK_X);
        menuItem.setAccelerator(KeyStroke.getKeyStroke( KeyEvent.VK_X, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.cutOp();
            }
        });
        m_editMenu.add(menuItem);
        // Copy
        menuItem = new JMenuItem("Copy");
        menuItem.setMnemonic(KeyEvent.VK_C);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.copyOp();
            }
        });
        m_editMenu.add(menuItem);
        // Paste
        menuItem = new JMenuItem("Paste");
        menuItem.setMnemonic(KeyEvent.VK_V);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.pasteOp();
            }
        });
        m_editMenu.add(menuItem);
        
        // Paste Special
        menuItem = new JMenuItem("Paste Special");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.pasteSpOp();
            }
        });
        m_editMenu.add(menuItem);
        m_editMenu.addSeparator();
        
        // Clear
        menuItem = new JMenuItem("Clear");
        menuItem.setMnemonic(KeyEvent.VK_DELETE);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0, true));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.clearOp();
            }
        });
        m_editMenu.add(menuItem);
        
        
        // Find
        m_editMenu.addSeparator();
        menuItem = new JMenuItem("Find/Replace...");
        menuItem.setMnemonic(KeyEvent.VK_F);
        menuItem.setAccelerator(KeyStroke.getKeyStroke
        (KeyEvent.VK_F, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_editMenuOp.find(true);
            }
        });
        m_editMenu.add(menuItem);
        
        
        
        //Set up Format Menu
        m_formatMenu = new JMenu("Format", true);
        m_formatMenu.setMnemonic(KeyEvent.VK_F);
        
        //set up tableMenu actions
        insertMenu = new JMenu("Insert");
        insertMenu.setMnemonic(KeyEvent.VK_I);
        
        menuItem = new JMenuItem("Row");
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.setAccelerator(KeyStroke.getKeyStroke
        (KeyEvent.VK_INSERT, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.insert(true);
            }
        });
        insertMenu.add(menuItem);
        
        menuItem = new JMenuItem("Column");
        menuItem.setMnemonic(KeyEvent.VK_C);
        menuItem.setAccelerator(KeyStroke.getKeyStroke
        (KeyEvent.VK_INSERT,
        ActionEvent.CTRL_MASK|
        ActionEvent.SHIFT_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.insert(false);
            }
        });
        insertMenu.add(menuItem);
        m_formatMenu.add(insertMenu);
        
        //set up Delete actions
        deleteMenu = new JMenu("Delete");
        deleteMenu.setMnemonic(KeyEvent.VK_D);
        menuItem = new JMenuItem("Row");
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.setAccelerator(KeyStroke.getKeyStroke
        (KeyEvent.VK_DELETE, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                //notYetImplemented();
                m_formatMenuOp.remove(true);
            }
        });
        deleteMenu.add(menuItem);
        menuItem = new JMenuItem("Column");
        menuItem.setMnemonic(KeyEvent.VK_C);
        menuItem.setAccelerator(KeyStroke.getKeyStroke
        (KeyEvent.VK_DELETE,
        ActionEvent.CTRL_MASK|
        ActionEvent.SHIFT_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                //notYetImplemented();
                m_formatMenuOp.remove(false);
            }
        });
        deleteMenu.add(menuItem);
        m_formatMenu.add(deleteMenu);
        
        m_formatMenu.addSeparator();
        
        // Set column width
        menuItem = new JMenuItem("Column Width");
        menuItem.setMnemonic(KeyEvent.VK_W);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.columnWidthOp();
            }
        });
        m_formatMenu.add(menuItem);
        // Row Height
        menuItem = new JMenuItem("Row Height");
        menuItem.setMnemonic(KeyEvent.VK_H);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.rowHeightOp();
            }
        });
        m_formatMenu.add(menuItem);
        // ADDED BY AL AUTOFIT
        menuItem = new JMenuItem("Autofit");
        menuItem.setMnemonic(KeyEvent.VK_F);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.columnAutofitOp();
            }
        });
        m_formatMenu.add(menuItem);
        // Format Cells
        m_formatMenu.addSeparator();
        menuItem = new JMenuItem("Format Cells...");
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_formatMenuOp.formatCellsOp();
            }
        });
        m_formatMenu.add(menuItem);
        
        //Set up Functions Menu
        m_functionsMenu = new JMenu("Functions", true);
        m_functionsMenu.setMnemonic(KeyEvent.VK_U);
        
        // Sum
        menuItem = new JMenuItem("Sum");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.sumOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        // Average
        menuItem = new JMenuItem("Average");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.averageOp();
            }
        });
        m_functionsMenu.add(menuItem);
        // Max
        menuItem = new JMenuItem("Max");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.maxOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        // Min
        menuItem = new JMenuItem("Min");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.minOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        // Square Root
        menuItem = new JMenuItem("Square Root");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.sqrtOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        // Sine
        menuItem = new JMenuItem("Sine");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.sineOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        // Count
        menuItem = new JMenuItem("Count");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_functionsMenuOp.countOp();
            }
        });
        m_functionsMenu.add(menuItem);
        
        
        
        //User Functions
        userFunction = new JMenu("User Defined",true);
        
        for(int x=0; x< userFunctionNames.size();x++) {
            //	System.out.println(x + "Name " +  userFunctionNames.elementAt(x).toString());
            
            
            JTable table=getTable();
            UMTableModel tablemodel=getTableModel();
            final Object[] tst ={this};
            final Method temp= (Method) userMethods.elementAt(x);
            
            //(UMTableModel table, Node node,int row, int col)
            
            menuItem = new JMenuItem(userFunctionNames.elementAt(x).toString());
            menuItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    
                    //      	System.out.println("Setting the Listner for: " + temp.toString());
                    
                    try{
                        temp.invoke(temp,tst);
                    }
                    catch (Exception EX )
                    {  	EX.printStackTrace();}
                }
            });
            userFunction.add(menuItem);
        }
        m_functionsMenu.add(userFunction);
        
        /***** Serey's new Code for about Button
         **/
        // Set up Help Menu
        m_helpMenu = new JMenu("Help", true);
        m_helpMenu.setMnemonic(KeyEvent.VK_H);
        
        
        // User Manual - Newly Added - JJ
        menuItem = new JMenuItem("User Manual");
        menuItem.setMnemonic(KeyEvent.VK_M);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M, ActionEvent.CTRL_MASK));
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                m_helpMenuOp.displayUserManual();
            }});
            m_helpMenu.add(menuItem);
            
            // About
            menuItem = new JMenuItem("About TerpSpreedsheet");
            menuItem.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_helpMenuOp.aboutBox();
                }
            });
            m_helpMenu.add(menuItem);
            
            
            
            /**** end of serey's new code for about button */
            
            
            
            
            //*******Popup Menu Method******
            m_popup = new PopupMenu("Edit");
            MenuItem mi;
            
            mi = new MenuItem("Format Cells...");
            mi.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_formatMenuOp.formatCellsOp();
                    m_table.requestDefaultFocus();
                }
            });
            m_popup.add(mi);
            m_popup.addSeparator();
            
            mi = new MenuItem("Cut");
            mi.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.cutOp();
                    m_table.requestDefaultFocus();
                }
            });
            m_popup.add(mi);
            
            mi = new MenuItem("Copy");
            mi.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.copyOp();
                    m_table.requestDefaultFocus();
                }
            });
            m_popup.add(mi);
            
            mi = new MenuItem("Paste");
            mi.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.pasteOp();
                    m_table.requestDefaultFocus();
                }
            });
            m_popup.add(mi);
            m_popup.addSeparator();
            
            mi = new MenuItem("Clear");
            mi.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.clearOp();
                    m_table.requestDefaultFocus();
                }
            });
            m_popup.add(mi);
            
            m_table.add(m_popup);
            m_table.addMouseListener(this);
            
            // set up menu bar and menus
            m_menuBar = new JMenuBar();
            m_menuBar.add(m_fileMenu);
            m_menuBar.add(m_editMenu);
            m_menuBar.add(m_formatMenu);
            m_menuBar.add(m_functionsMenu);
            m_menuBar.add(m_graphsMenu); //AMar
            // serey s
            m_menuBar.add(m_helpMenu);
            
            
            // button initializations
            JButton newButton = new JButton(newIcon);
            newButton.setToolTipText("New");
            newButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_fileMenuOp.newFile();
                    m_table.requestFocus();
                }
            });
            
            JButton openButton = new JButton(openIcon);
            openButton.setToolTipText("Open");
            openButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    int choice = 2;
                    if( m_tableModel.isModified() )/*FAULT:	if(!(m_tableModel.isModified()) )*/
                        choice = m_fileMenuOp.queryForSave();
                    if( choice == 0 )/*FAULT:	if( choice != 0 )*/
                        m_fileMenuOp.saveFile();
                    
                    m_fileMenuOp.openFile();
                    m_table.requestFocus();
                }
            });
            
            JButton saveButton = new JButton(saveIcon);
            saveButton.setToolTipText("Save");
            saveButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_fileMenuOp.saveFile();
                    m_table.requestFocus();
                }
            });
            
            JButton printButton = new JButton(printIcon);
            printButton.setToolTipText("Print");
            printButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_fileMenuOp.printFile();
                    m_table.requestFocus();
                }
            });
            
            JButton cutButton = new JButton(cutIcon);
            cutButton.setToolTipText("Cut");
            cutButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.cutOp();
                    m_table.requestFocus();
                }
            });
            
            JButton copyButton = new JButton(copyIcon);
            copyButton.setToolTipText("Copy");
            copyButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.copyOp();
                    m_table.requestFocus();
                }
            });
            
            JButton pasteButton = new JButton(pasteIcon);
            pasteButton.setToolTipText("Paste");
            pasteButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_editMenuOp.pasteOp();
                    m_table.requestFocus();
                }
            });
            // serey said remove bold & italics
            italicButton = new JToggleButton(italicIcon);
            italicButton.setToolTipText("Italic");
            italicButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_formatMenuOp.setItalicOp(italicButton.isSelected());
                    m_table.requestFocus();
                }
            });
            
            boldButton = new JToggleButton(boldIcon);
            boldButton.setToolTipText("Bold");
            boldButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    m_formatMenuOp.setBoldOp(boldButton.isSelected());
                    m_table.requestFocus();
                }
            });
            
            // format buttond serey
            JButton formatButton = new JButton( formatIcon );
            formatButton.setToolTipText("Format Button");
            formatButton.addActionListener( new ActionListener() {
                public void actionPerformed( ActionEvent evt ) {
                    m_formatMenuOp.formatCellsOp();
                    m_table.requestFocus();
                }
            });
            
            
            
            
            //=============================== ADDED BY AL formula bar
            formulaField = new JTextField();
            formulaField.setPreferredSize(new Dimension(300, 25));
            formulaField.setMaximumSize(new Dimension(500, 25));
            formulaField.setFont(new Font("DialogInput", Font.PLAIN, 12));
            formulaField.setMinimumSize(new Dimension(100, 25));
            formulaField.addMouseListener(this);
            formulaField.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.out.println("formula bar");
                    getFormulaBarInput();
                }
            });
            
            // initilize the undo.redo system inside constructor ADDED BY AL
            undoSupport.addUndoableEditListener(new UndoAdapter());
            refreshUndoRedo();
            
            //  Set up toolbar
            //  Toolbar can be customized in the configuration file.
            m_toolBar = new JToolBar();
            m_toolBar.setFloatable(true); // CHANGED BY AL FROM FALSE -> TRUE
            
            m_toolBar.add(newButton);
            m_toolBar.add(openButton);
            m_toolBar.add(saveButton);
            m_toolBar.addSeparator();
            m_toolBar.add(printButton);
            m_toolBar.addSeparator();
            m_toolBar.add(cutButton);
            m_toolBar.add(copyButton);
            m_toolBar.add(pasteButton);
            m_toolBar.addSeparator();
            
            //serey new code
            m_toolBar.add(formatButton);
            m_toolBar.addSeparator();
            
            // serey new code
            JPanel functionPanel = new JPanel();
            functionPanel.add( m_functionList );
            m_toolBar.add(functionPanel);
            m_toolBar.addSeparator();
            
            
            JPanel fontPanel = new JPanel();
            fontPanel.add(m_fontList);
            fontPanel.add(m_fontSizeList);
            
            m_toolBar.add(fontPanel);
            m_toolBar.addSeparator();
            m_toolBar.add(italicButton);
            m_toolBar.add(boldButton);
            
            newTableModel(m_maxCol+1, m_maxRow+1);
            // set window pos and size
            //int w = 600;
            //int h = 400;
            // set window pos and size serey
            w = m_config.getInt("WIDTH");
            h = m_config.getInt("HEIGHT");
            
            System.out.println("w is " + w );
            System.out.println("h is " + h );
            
            
            if (w >= 0 && h >= 0)
                m_table.setPreferredScrollableViewportSize(new Dimension(w, h));
            
            // init Operations objects
            // Change later to save clipboard info
            m_editMenuOp = new EditMenuOp(this);
            m_fileMenuOp = new FileMenuOp(this);
            m_formatMenuOp = new FormatMenuOp(this);
            m_functionsMenuOp = new FunctionsMenuOp(this);
            m_graphsMenuOp = new GraphsMenuOp( this ); //AMAR
            
            // serey
            m_helpMenuOp = new HelpMenuOp(this);
            
            // clobber resizing of all columns
            m_table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            
            // set table editor and renderer to custom ones DO THIS LATER
            m_table.setDefaultRenderer(UMCell.class, new UMCellRenderer());
            m_table.setDefaultEditor(UMCell.class, new UMCellEditor(new JTextField()));
            
            // set selection mode for contiguous intervals
            m_table.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
            m_table.setCellSelectionEnabled(true);
            
            // we don't allow reordering
            m_table.getTableHeader().setReorderingAllowed(false);
            m_table.getTableHeader().addMouseListener(new HeaderMouseAdapter());
            
            
            
            // create selection models
            m_rowSelectionModel = m_table.getSelectionModel();
            m_columnSelectionModel = m_table.getColumnModel().getSelectionModel();
            
            // add selection listeners to the selection models
            m_rowSelectionModel.addListSelectionListener(this);
            m_columnSelectionModel.addListSelectionListener(this);
            
            // set menu bar
            setJMenuBar(m_menuBar);
            // Set toolbar and inputBar on one Pane
            m_inputPane.add(m_toolBar, BorderLayout.NORTH);
            //m_container.add(m_inputPane, BorderLayout.NORTH); DELETED BY AL
            m_inputPane.add(formulaField, BorderLayout.SOUTH);  // ADDED BY AL
            m_container.add(m_inputPane, BorderLayout.NORTH); // ADDED BY AL FOR FORMULABAR
            m_scrollPane = new JScrollPane(m_table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
            m_container.add(m_scrollPane, BorderLayout.CENTER);
            
            // add window exit listener
            addWindowListener(new WindowAdapter() {
                public void windowOpened(WindowEvent evt) {
                    m_table.requestFocus();
                }
                
                public void windowClosing(WindowEvent evt) {
                    exit();
                }
            });
            
            // initial selection
            resetSelection();
            
            m_table.setRequestFocusEnabled(true);
            m_menuBar.setRequestFocusEnabled(false);
            m_toolBar.setRequestFocusEnabled(false);
            formulaField.setRequestFocusEnabled(true); //ADDED BY AL
            m_table.requestFocus();
            formulaField.requestFocus();// ADDED BY AL
            
            
            // Added by Michael Hill... implements dynamic sizing for the spreadsheet
            m_table.addKeyListener
            (new KeyAdapter() {
                public void keyPressed(KeyEvent e) {
                    int key = e.getKeyCode();
                    if ( ( key == KeyEvent.VK_ENTER) || ( key == KeyEvent.VK_DOWN ) ||
                    ( key == KeyEvent.VK_KP_DOWN ) ) {
                        if ( m_table.getSelectedRow() == (m_maxRow+m_baseRow) ) {
                            CellRange range = m_tableModel.getSelection() ;
                            m_tableModel.insertRow( range ) ;
                            m_maxRow++ ;
                        }
                    }
                    else if ( ( key == KeyEvent.VK_TAB ) || ( key == KeyEvent.VK_RIGHT ) ||
                    ( key == KeyEvent.VK_KP_RIGHT ) ) {
                        if ( m_table.getSelectedColumn() == (m_maxCol+m_baseCol) ) {
                            CellRange range = m_tableModel.getSelection() ;
                            m_tableModel.insertColumn( range ) ;
                            m_maxCol++ ;
                        }
                    }
                }
            });
            pack();
    }
    
    
    /** serey
     * Check the find next menu/button state
     * Enable only when the user has searched once
     */
    public void checkFindNextState() {
        findNextMenuItem.setEnabled(m_editMenuOp.hasFindValue());
    }
    
    /** Sets the width of the columns.
     *
     * @param colWidth specifics the width of the columns
     */
    public void setColumnWidth(int colWidth) {
        if (colWidth > 0)
            for (int i = m_baseCol; i < m_tableModel.getColumnCount(); i ++) {
                TableColumn column = m_table.getColumnModel().getColumn(i);
                column.setMinWidth(colWidth);
                column.setPreferredWidth(colWidth);
            }
    }
    
    /** Creates blank SharpTableModel object with the specified number of
     * rows and columns.  The table is set to this table model to update screen.
     *
     * @param rows number of rows in new table model
     * @param cols number of columns in new table model
     */
    public void newTableModel(int rows, int cols) {
        m_tableModel = new UMTableModel(this, rows, cols);
        m_table.setModel(m_tableModel);
        
        setBaseColumnWidth();
        setColumnWidth(80);
        
        m_tableModel.setModified(false);
        resetSelection();
        m_table.requestFocus();
    }
    
    /** Opens a spreadsheet from a file, used only in main.
     *
     * @param name filename
     */
    public void openInitFile(String name) {
        m_fileMenuOp.openTableModel(new File(name));
    }
    
    /** Exits the application.
     */
    public void exit() {
        // serey
        m_config.setInt("X", getX());
        m_config.setInt("Y", getY());
        
        Dimension dim = m_scrollPane.getViewport().getExtentSize();
        
        m_config.setInt("WIDTH", (int)dim.getWidth());
        m_config.setInt("HEIGHT", (int)dim.getHeight());
        m_config.save(); // saves the file
        //Newly Added - JJ
        fileHist.saveFileHistory(new File("recentFileHistory.log"));
        
        m_fileMenuOp.exitFile(1);
    }
    
    /** Checks the save menu button state.  Enabled only when the current file has
     * been modified.
     */
    public void checkSaveState() {
        boolean modified = m_tableModel.isModified();
        //saveMenuItem.setEnabled(modified);
        //saveButton.setEnabled(modified);
    }
    
    /** Initializes the width of the columns.
     */
    public void setBaseColumnWidth() {
        // resize first column
        if (m_baseCol > 0) {
            TableColumn firstColumn = m_table.getColumnModel().getColumn(m_baseCol - 1);
            int firstColWidth = 25;
            if (firstColWidth > 0) {
                firstColumn.setMinWidth(firstColWidth);
                firstColumn.setPreferredWidth(firstColWidth);
            }
        }
    }
    
    /** Starts up the spreadsheet as a stand alone aplication.
     *
     * @param args file name
     */
    public static void main(String args[]) {
        
        // serey modified this
        // read configuration file
        System.out.println("LOADING CONFIG FILE!!!!");
        //m_config = new Config("c:\\final\\umspreadsheet.ini");
        m_config = new Config("umspreadsheet.ini");

        
        m_config.load();
        Debug.setDebug(false);
        
        TerpSpreadSheet spreadsheet = new TerpSpreadSheet();
                

        spreadsheet.m_isStandAlone = true;
        
        if (args.length > 0){
            //System.out.println("----> "+args[0]);
            spreadsheet.openInitFile(args[0]);
        }
        
        //Load User Functions
        loadUserFunctionNames();
        loadUserGraphNames();
        
        Formula.registerFunctions();
        
        
        
        // Newly moved - JJ
        spreadsheet.show();
    }
    
    /** Should be used to updated the operations if table model changes.
     */
    public void updateOps() {
        m_formatMenuOp.updateTableModel();
    }
    
    /** Static function to help load spreadsheet images.
     *
     * @param name image name
     * @return location of the image
     */
    public static ImageIcon getImageIcon(String name) {
        URL url = ClassLoader.getSystemResource(name);
        if (url == null) {
            System.out.println("image " +name+ " not found");
            return null;
        }
        return new ImageIcon(url);
    }
    
    /** INTERFACE: ListSelectionListener
     * Sets the selection or the table, determines that the shortcut formating gui
     * is updated for the new selection.
     *
     * @param e current event
     */
    public void valueChanged(ListSelectionEvent e) {
        m_table.requestFocus();
        
        // Ignore extra messages
        if (e.getValueIsAdjusting()) {
            System.out.println( "value is adjusting" );
            return;
        }
        
        // Get event source
        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
        
        if (lsm.isSelectionEmpty()) {
            // always set selection
            m_table.setRowSelectionInterval(m_baseRow, m_baseRow);
            m_table.setColumnSelectionInterval(m_baseCol, m_baseCol);
        } else {
            // Get selected column
            if (m_table.getSelectedColumn() < m_baseCol) {
                int columnCount = m_table.getColumnCount();
                m_table.setColumnSelectionInterval(m_baseCol, columnCount - 1);
                m_table.removeColumnSelectionInterval(m_baseRow,m_baseRow);
            }
        }
        
        // Get the state of cells, and be ready to reset the gue
        CellRange cells = m_tableModel.getSelection();
        boolean italic = m_formatMenuOp.isItalic(cells);
        boolean bold = m_formatMenuOp.isBold(cells);
        String fontSize = m_formatMenuOp.getFontSize(cells);
        String fontName = m_formatMenuOp.getFontName(cells);
        
        boldButton.setSelected(bold);
        italicButton.setSelected(italic);
        
        // Update the formulaField with the contents of the newly selected cell
        CellPoint cp;
        cp = cells.getminCorner();
				//modified by Xun
        //formulaField.setText(m_tableModel.getCellAt(cp.getRow(), cp.getCol()).toString());
        formulaField.setText(m_tableModel.getCellAt(cp.getRow(), cp.getCol()).CellToString());
        
        
        // Declare final stuff to use in the later funciton
        final String fFontName = fontName;
        final String fFontSize = fontSize;
        
        // Set this on event dispach thread
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                for (int i = 0; i < m_fontList.getItemCount(); i++) {
                    //System.out.println(
                    //   (String)m_fontList.getItemAt(i) +
                    //   " " + fFontName);
                    
                    if (((String)m_fontList.getItemAt(i)).compareTo(fFontName) == 0) {
                        m_fontList.setSelectedIndex(i);
                        break;
                    }
                }
                for (int i = 0; i < m_fontSizeList.getItemCount(); i++) {
                    if (((String)m_fontSizeList.getItemAt(i)).compareTo(fFontSize) == 0) {
                        m_fontSizeList.setSelectedIndex(i);
                        break;
                    }
                }
            }});
    }
    
    /** Resets the selection to the first row and first column.
     */
    public void resetSelection() {
        m_table.setRowSelectionInterval(m_baseRow, m_baseRow);
        m_table.setColumnSelectionInterval(m_baseCol, m_baseCol);
    }
    
    // INTEFACE: MouseAdapter
    /** indicates the current action being performed.
     *
     * @param e current action
     */
    public void actionPerformed(ActionEvent e) {}
    /** unused.
     *
     * @param e none
     */
    public void mouseEntered(MouseEvent e){}
    /** unused.
     *
     * @param e none
     */
    public void mouseExited(MouseEvent e){}
    /** unused.
     *
     * @param e none
     */
    public void mouseReleased(MouseEvent e){}
    /** unused.
     *
     * @param e none
     */
    public void mousePressed(MouseEvent e) {
    }
    
    /** Displays the popup menu when clicked.
     *
     * @param e mouse click event
     */
    public void mouseClicked(MouseEvent e) {
        if (e.getModifiers() == InputEvent.BUTTON3_MASK)/*FAULT:	if (e.getModifiers() != InputEvent.BUTTON3_MASK)*/
            m_popup.show(e.getComponent(), e.getX(), e.getY());
    }
    
	  /**
* This class is the mouse listener for the table and is responsible for
	* all of the mouse actions.
	* @author TSS
	* @version 3.0
	*/
    class HeaderMouseAdapter extends MouseAdapter {
        
        /** Determines if the mouse action has occured.
         * @param e mouse click event
         */
        public void mouseClicked(MouseEvent e) {
            TableColumnModel colModel = m_table.getColumnModel();
            int col = colModel.getColumn(colModel.getColumnIndexAtX(e.getX())).getModelIndex();
            
            int rowCount = m_table.getRowCount();
            m_table.setRowSelectionInterval(m_baseRow, rowCount - 1);
            
            if (col < m_baseCol)
                m_table.setColumnSelectionInterval(m_baseCol, m_table.getColumnCount()-1);
            else
                m_table.setColumnSelectionInterval(col, col);
        }
    }
    
    /** INTEFACE: TerpOffice
     * Used to exit the application without invoking system.exit.
     */
    public void close() {
        if (alive())
            exit();
        //TerpOffice.removeApps(this);
    }
    
    /** Starts up the spreadsheet within an office.
     *
     * @param file configuration file name
     */
    public void launch(File file) {
        // read configuration file
        //m_config = new Config("umspreadsheet.ini");
        
        Debug.setDebug(false);
        
        //TerpSpreadSheet spreadsheet = new TerpSpreadSheet();
        this.show();
        if (file != null)
            m_fileMenuOp.openTableModel(file);
        Formula.registerFunctions();
    }
    
    /** Returns true if spreadsheet window has not been disposed yet.
     *
     * @return determines if spreadsheet is available
     */
    public boolean alive() {
        return isDisplayable();
    }
    
	/**
* Starts to print the file if need be.
	*
	* @param file File
	* @return true if file was able to be printed
	*/
    public boolean TerpPrint(File file) {
        m_fileMenuOp.setFile( file );
        m_fileMenuOp.printData();
        return true;
    }
	/**
			 * This function sets the values for the Formula bar.
			 */
    private void getFormulaBarInput() {
        //debugMessage("WebSheetApplet.getFormulaBarInput()\n");
        int selectedRow = m_table.getSelectedRow();
        int selectedColumn = m_table.getSelectedColumn();
        
        int VjsbValue = m_scrollPane.getVerticalScrollBar().getValue();
        int HjsbValue = m_scrollPane.getHorizontalScrollBar().getValue();
        
        if (selectedRow >= 0 && selectedColumn >= 0) {
            m_tableModel.setValueAt(formulaField.getText(), selectedRow, selectedColumn);
            m_table.changeSelection(selectedRow, selectedColumn, false, false);
        }
        
        m_scrollPane.getVerticalScrollBar().setValue(VjsbValue);
        m_scrollPane.getHorizontalScrollBar().setValue(HjsbValue);
        
        formulaField.requestFocus();
    }
    // ADDED BY AL
    /** This method will refresh the edit menu to indicate when a
     * undo or redo can occur.
     *
     */
    public void refreshUndoRedo() {
        System.out.println("refreshundoredo");
        // refresh undo
        m_editMenu.getItem(0).setText(undoManager.getUndoPresentationName());
        m_editMenu.getItem(0).setEnabled(undoManager.canUndo());
        
        // refresh redo
        m_editMenu.getItem(1).setText(undoManager.getRedoPresentationName());
        m_editMenu.getItem(1).setEnabled(undoManager.canRedo());
        System.out.println("refreshed exit");
    }
	/**
		 * Class: UndoAdapter
		 * Description: This adapter is created to determine if a clear/cut/paste operation
		 * has occured so that the undomanager can register it and create
		 * the undo/redo functionality.
		 * 
		 * @author Spring 2003
		 * @version 2.0
		 * @see UndoableEditListener
		 */
    private class UndoAdapter implements UndoableEditListener {
        /** This adaptor is created to determine if a clear/cut/paste operation
         * has occured so that the undomanager can register it and create
         * the undo/redo functionality.
         *
         * @param evt the event that occured
         */
        public void undoableEditHappened(UndoableEditEvent evt) {
            System.out.println("the adaptor");
            undoManager.addEdit(evt.getEdit());
            refreshUndoRedo();
            System.out.println("the adaptor exited");
        }
    }
    
    /** Method that determines if no cells have been selected.
     *
     * @param s string
     */
    public void noCellsSelected(String s) {
        UMOptionPane.showMessageDialog(this, s + ": No cells selected","Error", JOptionPane.ERROR_MESSAGE, null);
    }
    
    //Newly added - JJ
    /** This method returns the file history log.
     *
     * @return name of the file history log
     */
    public FileHistory getFileHistory() {
        return fileHist;
        
        
    }
    /** Laods the User Defined Graph names */
    private static void loadUserGraphNames() {
        System.out.println("Reading in user Fx Names");
        if ( userGraphs == null ) {
            loadUserGraphs();
            userGraphNames = new Vector();
            for ( int m = 0; m < userGraphs.size(); m++ ) {
                userGraphNames.add( ((Method)(userGraphs.get(m))).getName() );
                System.out.println(((Method)(userGraphs.get(m))).getName() );
            }
        }
    } // loadUserGraphNames ()
    
    
    /** Laods the User Defined function names */
    private static void loadUserFunctionNames() {
        System.out.println("Reading in user Gx Names");
        if ( userMethods == null ) {
            loadUserMethods();
            userFunctionNames = new Vector();
            for ( int m = 0; m < userMethods.size(); m++ ) {
                userFunctionNames.add( ((Method)(userMethods.get(m))).getName() );
                System.out.println(((Method)(userMethods.get(m))).getName() );
            }
        }
    } // loadUserFunctionNames ()
    
    /** Laods the User Defined function methods */
    private static void loadUserMethods() {
        System.out.println("Loading in user Fx Names");
        Class ufClass = null;
        ClassLoader loader = ClassLoader.getSystemClassLoader();
        LinkedList validMethods = new LinkedList();
        ListIterator lIter = null;
        
        System.out.println("Reading in user methods");
        // attempt to load user-defined functions
        if ( userFunctionsClass != null ) {
            try {
                // attempt to load the user-defined class
                ufClass = loader.loadClass( userFunctionsClass );
                validMethods.addAll( getValidMethods( ufClass ) );
            }
            catch ( ClassNotFoundException cnfe ) {
                // don't add any user-defined functions....
            }
        }
        
        userMethods = new Vector();
        
        // put valid methods into Vector of base Methods
        lIter = validMethods.listIterator();
        for ( int m = 0; lIter.hasNext(); m++ ) {
            userMethods.add( lIter.next() );
            //System.out.println("YO: "+lIter.next());
            System.out.println("A:"+ userMethods.elementAt(m).toString());
        }
        
        
    } // loadUserMethods ()
    
    /** Laods the User Defined graph methods */
    private static void loadUserGraphs() {
        System.out.println("Loading in user Gx Names");
        Class ufClass = null;
        ClassLoader loader = ClassLoader.getSystemClassLoader();
        LinkedList validMethods = new LinkedList();
        ListIterator lIter = null;
        
        System.out.println("Reading in user graphs");
        // attempt to load user-defined functions
        if ( userGraphsClass != null ) {
            try {
                // attempt to load the user-defined class
                ufClass = loader.loadClass( userGraphsClass );
                validMethods.addAll( getValidMethods( ufClass ) );
            }
            catch ( ClassNotFoundException cnfe ) {
                // don't add any user-defined functions....
            }
        }
        
        userGraphs = new Vector();
        
        // put valid methods into Vector of base Methods
        lIter = validMethods.listIterator();
        for ( int m = 0; lIter.hasNext(); m++ ) {
            userGraphs.add( lIter.next() );
            //System.out.println("YO: "+lIter.next());
            System.out.println("A:"+ userGraphs.elementAt(m).toString());
        }
    } // loadUserMethods ()
    
    /** Returns a <code>Vector</code> containing the names (<code>Strings</code>) of the user-defined
     * functions recognized by <code>Grapher</code> and available for use in postfix expressions.
     * @return names (<code>Strings</code>) of user-defined functions recognized by <code>Grapher</code>.<br>
     */
    public static Vector getUserFunctionNames() {
        System.out.println("Getting  user Fx Names");
        Vector functionNames = new Vector();
        
        if ( userFunctionNames == null ) loadUserFunctionNames();
        
        functionNames.addAll( userFunctionNames );
        
        System.out.println("----");
        return functionNames;
    } // getUserFunctionNames ()
    
    /** Returns a <code>Vector</code> containing the names (<code>Strings</code>) of the user-defined
     * functions recognized by <code>Grapher</code> and available for use in postfix expressions.
     * @return names (<code>Strings</code>) of user-defined functions recognized by <code>Grapher</code>.<br>
     */
    public static Vector getUserGraphNames() {
        System.out.println("GEtting user Gx Names");
        Vector graphNames = new Vector();
        
        if ( userGraphNames == null ) loadUserGraphNames();
        
        graphNames.addAll( userGraphNames );
        
        System.out.println("----");
        return graphNames;
    } // getUserFunctionNames ()
    
	/** Gets all the valid methods from user defined classes
		 * @param c -User Class
		 * @return Linked List of methods 
		 * 		*/    
    private static LinkedList getValidMethods( Class c ) {
        boolean stop = false;
        int methodIndex = 0;
        Class [] params = null;
        Class returnType = null;
        LinkedList validMethods = new LinkedList();
        Method [] methods = null;
        Method method = null;
        String className = null;
        Vector methodNames = new Vector();
        Vector methodParams = new Vector();
        
        if ( c != null ) {
            // get the methods defined by the user
            methods = c.getMethods();
            
            // add any methods that take at least one primitive number type (pnt) parameter
            // (and only pnt's as parameters) and return a pnt.
            for ( int m = 0; m < methods.length; m++ ) {
                method = methods[m]; // get the current method to test
                
                if ( Modifier.isStatic( method.getModifiers() )
                && Modifier.isPublic( method.getModifiers() ) ) {
                    returnType = method.getReturnType();
                    params = method.getParameterTypes();
                    
                    // make sure the return type is a primitive number type
                    className = returnType.getName();
                    System.out.println("Return type: "+ className.toString());
                    if ( params.length > 0 &&
                    ( className.equals( "double" ) || className.equals( "float" )
                    || className.equals( "int" ) || className.equals( "long" ) || className.equals( "java.lang.Number" )|| className.equals( "void" ) ) ) {
                        // make sure each parameter to the method is a primitive number type
                        stop = false;
                        for ( int p = 0; p < params.length && !stop; p++ ) {
                            className = params[p].getName();
                            System.out.println("Parameter type: "+ className.toString());
                            stop = !( className.equals( "double" ) || className.equals( "float" )
                            || className.equals( "int" ) || className.equals( "long" )|| className.equals( "Node" )|| className.equals( "UMTableModel" )  );
                        }
                        
                        // if ( !stop ) // all parameters are primitive number types, so save this valid Method
                        //{
                        // only add the method if it has a unique ( name, number of parameters ) quality
                        // the BeanShell javaInterpreter will resolve the overloaded methods :)
                        methodIndex = methodNames.indexOf( method.getName() );
                        if ( methodIndex == -1
                        || ((Integer)(methodParams.get( methodIndex ))).intValue() != params.length ) {
                            validMethods.addLast( method );
                            methodNames.add( method.getName() );
                            methodParams.add( new Integer( params.length ) );
                        }
                        //}
                    }
                }
            }
        }
        
        return validMethods;
    } // getValidMethods ()
    
    // protected void processKeyEvent( new KeyEvent( this, KeyEvent.KEY_TYPED,
}


