/*
 * @(#)FindDialog.java
 *
 * $Id: FindDialog.java,v 1.3 2001/05/27 22:28:57 huaz Exp $
 *
 * Created on November 28, 2000, 02:12 AM
 */

import java.awt.BorderLayout;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * This class provides a find dialog.
 * User is prompted to choose find options.
 *
 * @author Serey Lay
 * @version 1.4
 * @see SharpDialog
 */
public class FindDialog extends SharpDialog {
    
	/** store the JLabel object */
	private JLabel label;
	/** store the JFrame object */
	private JFrame frame;
	/** text field of the dialog */
	final private JTextField textField = new JTextField(10);
	/** check box to select case sensitive */
	private JCheckBox caseSensitiveBox;
	/** check box to select match cell */
	private JCheckBox matchCellBox;
	/** store the typed string */
	private String typedText = null;
	/** store the case sensitive option */
	private boolean caseSensitive = false;
	/** store the match cell option */
	private boolean matchCell = false;
	/** store the image */
	final private ImageIcon findIcon = TerpSpreadSheet.getImageIcon("find32.gif");
    
	//-------------------------
	// following was added by JJdESi4
	/** another text field */
	final private JTextField textField2 = new JTextField(10);
	/** another String*/
	private String typedText2 = null;
	//-------------------------    
    
    
    
	 /**
* Constructor for FindDialog that starts to create the find dialog
	*  which extends from SharpDialog
	* @param aFrame creates the frame
	* @param findValue the value to be found
	* @param second Bollean 
	* @param oldFind string of the search
	* @param mCell bollean Cell
	* @param replaceValue String replace value
	* @param mCase bolean case
	* @param oldReplace String Old Replace
	*/
    public FindDialog(JFrame aFrame, String findValue, String replaceValue, boolean mCase,
    boolean mCell,boolean second, String oldFind, String oldReplace) {
        super(aFrame, "Find/Replace", true);
        
        
        //-------------------------------------
        // following added by JJdESi4
        if(second == true)
        {
            textField.setText(oldFind);
            textField2.setText(oldReplace);
        }
        else
        {
            textField.setText(findValue);
            textField2.setText(replaceValue);
        }
        //-------------------------------------
        
        caseSensitiveBox = new JCheckBox("Match Case");
        caseSensitiveBox.setMnemonic(KeyEvent.VK_M);
        caseSensitiveBox.setSelected(mCase);
        
        matchCellBox = new JCheckBox("Match Entire Cell Only");
        matchCellBox.setMnemonic(KeyEvent.VK_E);
        matchCellBox.setSelected(mCell);
        
        JPanel box = new JPanel(new BorderLayout(0, 5));
        
        box.add(textField, BorderLayout.NORTH);
        //JJdESi4
        box.add(textField2, BorderLayout.SOUTH);
        //----------
        box.add(caseSensitiveBox, BorderLayout.WEST);
        box.add(matchCellBox, BorderLayout.EAST);
        
        setOptionPane(box,
        JOptionPane.PLAIN_MESSAGE,
        JOptionPane.OK_CANCEL_OPTION,
        findIcon);
    }
    
    /** Checks what you want to find is case sensitive
     * @return true or false
     */
    public boolean isCaseSensitive(){
        return caseSensitive;
    }
    
    /** Checks if the cell matches
     * @return true or false
     */
    public boolean isCellMatching(){
        return matchCell;
    }
    
    /** Returns a string value of the text typed
     * @return text typed
     */ 
    public String getString(){
        return typedText;
    }
    
    //---------------------------------
    // following was added by JJdESI4
	/** Returns a string value of the text typed
		 * @return text typed
		 */ 
    public String getString2()
    {
        return typedText2;
    }
    
    /** Function to create the Find Button text field
     * 
     */
    protected void onOpen() {
        textField.selectAll();
        textField.requestFocus();
    }
    
    /** Returns a boolean that this is the object that you want to see
     * @return true always
     */
    protected boolean onOK() {
        typedText = textField.getText();
        
        //JJdESi4
        typedText2 = textField2.getText();
        //----------------------
        caseSensitive = caseSensitiveBox.isSelected();
        matchCell = matchCellBox.isSelected();
	return false;
    }
    
    
    
}
