import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** The FormatMenuOp tabs.
 *  @author TSS
 * @version 2.1
 */
public class FormatCellsTabs extends JTabbedPane {
     
	/**
  * Dialog - main 
  */
 JDialog m_dialog;
 /**
  * Format Menu
  */
 FormatMenuOp m_formatMenuOp;
 /**
  *  Background color
  */
 Color m_bColor = null;
 /**
  * Font color
  */
 Color m_fColor = null;
 /**
  *  Font Panel
  */
    JPanel m_fontPane = new JPanel();
   
       
	/**
	  * Border Layout
	  */
	 BorderLayout borderLayout1 = new BorderLayout();
	 /**
	  * Color Panel
	  */
	 JPanel m_ColorPane = new JPanel();
	 /**
	  * Ok button
	  */
	 JButton m_fontOk = new JButton();
	 /**
	  * Cancel button
	  */
	 JButton m_fontCancel = new JButton();
	 /**
	  * Font Pane
	  */
	 JPanel m_FontPane = new JPanel();
	 /**
	  * Grid Background Layout
	  */
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    /**
	 *  Font Combo List
	 */
	JComboBox m_fontList = new JComboBox();
	/**
	 *  Font Style Combo List
	 */
	JComboBox m_styleList = new JComboBox();
	/**
	 *  Font Size Combo List
	 */
	JComboBox m_sizeList = new JComboBox();
	/**
	 *  Font Label
	 */
	JLabel m_fontLabel = new JLabel();
	/**
	 *  Style Label
	 */
	JLabel m_styleLabel = new JLabel();
	/**
	 * Size Label
	 */
	JLabel m_sizeLabel = new JLabel();
	/**
	 *  Last Pane
	 */
	JPanel m_LastPane = new JPanel();
	/**
	 *  Grid Layout
	 */
    GridLayout gridLayout1 = new GridLayout();
       
	/**
	  *  Label1
	  */
	 JLabel jLabel1 = new JLabel();
	 /**
	  *  Background Color Button
	  */
	 JButton m_backGroundButton = new JButton();
	 /**
	  *  Label2
	  */
	 JLabel jLabel2 = new JLabel();
	 /**
	  *  Font Color Button
	  */
	 JButton m_fontColorButton = new JButton();
	 /**
	  *  Border Panel
	  */
	 JPanel m_borderPane = new JPanel();
	 /**
	  *  Border Layout 2
	  */
	 BorderLayout borderLayout2 = new BorderLayout();
	 /**
	  *  Border Selection Panel
	  */
	 JPanel m_borderSelectionPane = new JPanel();
	 /**
	  *  Border OK Button
	  */
    JButton m_borderOk = new JButton();
    
	/**
	  * Border Cancel Button
	  */
	 JButton m_borderCancel = new JButton();
	 /**
	  *  Broder Buttons Panel
	  */
	 JPanel m_borderButtons = new JPanel();
	 /**
	  *  Flow Layout
	  */
	 FlowLayout flowLayout1 = new FlowLayout();
	 /**
	  *  Inside Border Toggle Button
	  */
	 JToggleButton m_insideBrdButton = new JToggleButton();
	 /**
	  * Outside Border Toggle Button
	  */
	 JToggleButton m_outsideBrdButton = new JToggleButton();
	 /**
	  *  No Border Toggle Button
	  */
	 JToggleButton m_noBrdButton = new JToggleButton();
    
	 /**
	  *  Dummy Label
	  */
	 JLabel dummyLabel = new JLabel();
	 /**
	  *  Font Demo Text Field
	  */
    JTextField fontDemo = new JTextField();
    
    
    /** This constructs the gue dialog for formating cells.
     *
     * @param op The option selected.
     * @param d The dialog box selected.
     */
    public FormatCellsTabs(FormatMenuOp op, JDialog d) {
        try {
            m_dialog = d;
            m_formatMenuOp = op;
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    
     /**
     * jbInit
     * Description: This method was build with jBuilder to
     *              initialize the gue.
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        m_fontPane.setLayout(borderLayout1);
        m_fontOk.setToolTipText("");
        m_fontOk.setText("Ok");
        m_fontOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fontOkOp();
            }
        });
        m_fontCancel.setText("Cancel");
        m_fontCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fontCancelOp();
            }
        });
        m_FontPane.setLayout(gridBagLayout1);
        m_fontLabel.setText("Font");
        m_styleLabel.setText("Style");
        m_sizeLabel.setText("Size");
        m_LastPane.setLayout(gridLayout1);
        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("Background Color");
        m_backGroundButton.setText("Choose background...");
        m_backGroundButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                backgroundColorOp();
            }
        });
        gridLayout1.setColumns(3);
        gridLayout1.setRows(2);
        jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel2.setText("Font Color");
        fontDemo.setHorizontalAlignment(SwingConstants.CENTER);
        fontDemo.setText("Text Colors");
        m_fontColorButton.setText("Choose font color...");
        m_fontColorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fontColorOp();
            }
        });
        
        String [] fontStyles = { "[Automatic]", "Regular", "Bold",
        "Italic", "Italic Bold"};
        
        m_styleList = new JComboBox(fontStyles);
        m_styleList.setBackground(Color.white);
        
        
        java.awt.GraphicsEnvironment ge =
        java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        String[] fontNames = ge.getAvailableFontFamilyNames();
        m_fontList = new JComboBox();
        m_fontList.addItem("[Automatic]");
        for (int i = 0; i < fontNames.length; i++)
            m_fontList.addItem(fontNames[i]);
        
        m_fontList.setBackground(Color.white);
        
        
        String [] fontSizes = { "-", "8", "9", "10", "11", "12", "14",
        "16","18", "20", "24", "26", "28" ,"36", "48",
        "72"};
        
        m_sizeList = new JComboBox(fontSizes);
        m_sizeList.setBackground(Color.white);
        
        m_borderPane.setLayout(borderLayout2);
        m_borderOk.setText("Ok");
        m_borderOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                borderOkOp();
            }
        });
        
        m_borderCancel.setText("Cancel");
        m_borderCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                borderCancelOp();
            }
        });
        
        m_borderButtons.setLayout(flowLayout1);
        flowLayout1.setHgap(20);
        flowLayout1.setVgap(20);
        m_insideBrdButton.setMaximumSize(new Dimension(150, 25));
        m_insideBrdButton.setMinimumSize(new Dimension(150, 25));
        m_insideBrdButton.setPreferredSize(new Dimension(150, 25));
        m_insideBrdButton.setText("Inside Border");
        m_insideBrdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (m_insideBrdButton.isSelected())
                    m_noBrdButton.setSelected(false);
            }
        });
        
        m_outsideBrdButton.setPreferredSize(new Dimension(150, 25));
        m_outsideBrdButton.setText("Outside Border");
        m_outsideBrdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (m_outsideBrdButton.isSelected())
                    m_noBrdButton.setSelected(false);
            }
        });
        
        m_noBrdButton.setMaximumSize(new Dimension(150, 25));
        m_noBrdButton.setMinimumSize(new Dimension(150, 25));
        m_noBrdButton.setPreferredSize(new Dimension(150, 25));
        m_noBrdButton.setText("No Border");
        m_noBrdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (m_noBrdButton.isSelected()) {
                    m_insideBrdButton.setSelected(false);
                    m_outsideBrdButton.setSelected(false);
                }
            }
        });
        
        m_ColorPane.add(m_fontOk, null);
        m_ColorPane.add(m_fontCancel, null);
        m_fontPane.add(m_FontPane, BorderLayout.NORTH);
        m_fontPane.add(m_ColorPane, BorderLayout.SOUTH);
        m_FontPane.add(m_fontList,    new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_FontPane.add(m_styleList,   new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_FontPane.add(m_sizeList,   new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_FontPane.add(m_fontLabel,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_FontPane.add(m_styleLabel,  new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_FontPane.add(m_sizeLabel,  new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        m_fontPane.add(m_LastPane, BorderLayout.CENTER);
        m_LastPane.add(jLabel1, null);
        m_LastPane.add(dummyLabel, null);
        m_LastPane.add(jLabel2, null);
        m_LastPane.add(m_backGroundButton, null);
        m_LastPane.add(fontDemo, null);
        m_LastPane.add(m_fontColorButton, null);
        this.add(m_fontPane,  "Font");
        this.add(m_borderPane,  "Border");
        m_borderPane.add(m_borderSelectionPane, BorderLayout.SOUTH);
        m_borderSelectionPane.add(m_borderOk, null);
        m_borderSelectionPane.add(m_borderCancel, null);
        m_borderPane.add(m_borderButtons, BorderLayout.CENTER);
        m_borderButtons.add(m_insideBrdButton, null);
        m_borderButtons.add(m_outsideBrdButton, null);
        m_borderButtons.add(m_noBrdButton, null);
    }
    
    /**
     * fontOkOp
     * Description: executed when an ok button on a font tab is
     *              pressed
     */
    void fontOkOp() {
        m_dialog.setVisible(false);
        boolean bold = false;
        boolean italic = false;
        boolean regular = false;
        String fontName = (String) (m_fontList.getSelectedItem());
        String fontSize = (String) (m_sizeList.getSelectedItem());
        
        String fontStyle = (String) (m_styleList.getSelectedItem());
        if (fontStyle.compareTo("Bold") == 0)
            bold = true;
        if (fontStyle.compareTo("Italic") == 0)
            italic = true;
        if (fontStyle.compareTo("Regular") == 0)
            regular = true;
        if (fontStyle.compareTo("Italic Bold") == 0) {
            bold = true;
            italic = true;
        }
        
        m_formatMenuOp.doAllFont(bold,
        italic,
        regular,
        fontName,
        fontSize,
        m_bColor,
        m_fColor);
    }
    /**
     * fontCanceOp
     * Description: executed when a cacel button on a font tab is
     *              pressed
     */
	void fontCancelOp() {m_dialog.setVisible(true);}
    /**
     * borderOkOp
     * Description: executed when an ok button on a border tab is
     *              pressed
     */
    void borderOkOp() {
        m_dialog.setVisible(false);/*FAULT:	m_dialog.setVisible(true);*/
        m_formatMenuOp.doAllBorder(m_insideBrdButton.isSelected(),
        m_outsideBrdButton.isSelected(),
        m_noBrdButton.isSelected());
        
    }
    /**
     * borderCancelOp
     * Description: executed when a cancel  button on a border tab is
     *              pressed
     */
    void borderCancelOp() {m_dialog.setVisible(false);}/*FAULT:	void borderCancelOp() {m_dialog.setVisible(true);}*/
    
    /**
     * backgroundColorOp
     * Description: executed when a background color button is
     *              pressed
     */
    void backgroundColorOp() {
        m_bColor = JColorChooser.showDialog(m_dialog,
        "Background Color",
        m_bColor);
        if (m_bColor != null)
            fontDemo.setBackground(m_bColor);
    }
    /**
     * fontColorOp
     * Description: executed when a font color button is
     *              pressed
     */
    void fontColorOp() {
        m_fColor = JColorChooser.showDialog(m_dialog,
        "Font Color",
        m_fColor);
        if (m_fColor != null)
            fontDemo.setForeground(m_fColor);
    }
    
    /** Called when the dialog need to be displayed, sets everything to correct intial values
     * @param isBold true if bold
     * @param isItalic true if italic
     * @param isRegular true if regular font.
     * @param fontSize the font size.
     * @param fontName The font name.
     * @param bColor The font color.
     * @param fColor The font color.
     * @param isInsideBorder true if inside border.
     * @param isOutsideBorder true if outside border.
     * @param isNoBorder true if no border.
     */
    public void displayDialog( boolean isBold,
    boolean isItalic,
    boolean isRegular,
    String fontSize,
    String fontName,
    Color bColor,
    Color fColor,
    boolean isInsideBorder,
    boolean isOutsideBorder,
    boolean isNoBorder) {
        String fontStyle = "[Automatic]";
        if (isRegular)
            fontStyle = "Regular";
        else if (isBold && isItalic)/*FAULT:	else if (!isBold || !isItalic)*/
            fontStyle = "Italic Bold";
        else if (isBold)/*FAULT:	else if (!isBold)*/
            fontStyle = "Bold";/*FAULT:	fontStyle = "Italic";*/
        else if (isItalic)/*FAULT:	else if (!isItalic)*/
            fontStyle = "Italic";/*FAULT:	fontStyle = "Bold";*/
        
        m_bColor = bColor;
        m_fColor = fColor;
        
        setComboBox(m_styleList, fontStyle);
        setComboBox(m_sizeList, fontSize);
        setComboBox(m_fontList, fontName);
        
        m_insideBrdButton.setSelected(isInsideBorder);
        m_outsideBrdButton.setSelected(isOutsideBorder);
        m_noBrdButton.setSelected(isNoBorder);
        
        setSelectedIndex(0);
        if (m_bColor != null)
            fontDemo.setBackground(m_bColor);
        if (m_fColor != null)
            fontDemo.setForeground(m_fColor);
    }
    
    /** helper to set value in a combobox
     * @param box The combo box.
     * @param value The name of the combo box.
     */
    public void setComboBox(JComboBox box, String value) {
        for (int i = 0; i < box.getItemCount(); i++) {
            if (((String)box.getItemAt(i)
            ).compareTo(value) == 0) {
                box.setSelectedIndex(i);
                break;
            }
        }
    }
}
